<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../../common/meta';
import { NextStep } from '../../components/common/index.vue';
import {
  Conduct,
  LightningHero,
  Intro,
  Section,
  FeaturedSpeaker,
  FeaturedContent,
} from '../../components/events/index.vue';
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  standardEventsDataHelper,
  EventData,
} from '~/services/events/events.service';

export default Vue.extend({
  components: {
    LightningHero,
    Intro,
    Section,
    FeaturedSpeaker,
    FeaturedContent,
    Conduct,
    NextStep,
  },
  nuxtI18n: false,
  async asyncData() {
    const content: EventData = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.EVENT,
        include: 10,
        'sys.id': '3nE6WmWtOYMFk7WJPhmRT6',
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;
        return standardEventsDataHelper(entryFields);
      })
      .catch(console.error);
    return { content };
  },
  head() {
    return getPageMetadata((this as any).content.metadata, this.$route.path);
  },
});
</script>

<template>
  <div>
    <LightningHero v-if="content.hero" :data="content.hero" centered />
    <Intro v-if="content.description" :data="content.description" />
    <Section
      v-for="(item, index) in content.booth"
      :key="index"
      class="slp-pb-32"
      :data="item"
    />
    <FeaturedSpeaker
      v-for="(session, sessionIndex) in content.sessions"
      :key="sessionIndex"
      :data="session"
    />
    <Section
      v-for="socialEvent in content.social"
      :key="socialEvent.header"
      :data="socialEvent"
    />

    <FeaturedContent
      v-if="content.featuredContent"
      :data="content.featuredContent"
    />
    <div v-if="content.footnote">
      <Conduct
        v-for="footnote in content.footnote"
        :key="footnote.header"
        :data="footnote"
      />
    </div>
    <NextStep :variant="content.nextSteps" />
  </div>
</template>
